searchData={"items":[{"type":"module","title":"Libtailscale","doc":"","ref":"Libtailscale.html"},{"type":"function","title":"Libtailscale.accept/2","doc":"","ref":"Libtailscale.html#accept/2"},{"type":"function","title":"Libtailscale.close/1","doc":"","ref":"Libtailscale.html#close/1"},{"type":"function","title":"Libtailscale.close_connection/2","doc":"","ref":"Libtailscale.html#close_connection/2"},{"type":"function","title":"Libtailscale.close_listener/2","doc":"","ref":"Libtailscale.html#close_listener/2"},{"type":"function","title":"Libtailscale.dial/3","doc":"","ref":"Libtailscale.html#dial/3"},{"type":"function","title":"Libtailscale.getips/1","doc":"","ref":"Libtailscale.html#getips/1"},{"type":"function","title":"Libtailscale.getremoteaddr/3","doc":"","ref":"Libtailscale.html#getremoteaddr/3"},{"type":"function","title":"Libtailscale.init/0","doc":"","ref":"Libtailscale.html#init/0"},{"type":"function","title":"Libtailscale.listen/3","doc":"","ref":"Libtailscale.html#listen/3"},{"type":"function","title":"Libtailscale.loopback/1","doc":"","ref":"Libtailscale.html#loopback/1"},{"type":"function","title":"Libtailscale.new/0","doc":"","ref":"Libtailscale.html#new/0"},{"type":"function","title":"Libtailscale.read/3","doc":"","ref":"Libtailscale.html#read/3"},{"type":"function","title":"Libtailscale.set_authkey/2","doc":"","ref":"Libtailscale.html#set_authkey/2"},{"type":"function","title":"Libtailscale.set_control_url/2","doc":"","ref":"Libtailscale.html#set_control_url/2"},{"type":"function","title":"Libtailscale.set_dir/2","doc":"","ref":"Libtailscale.html#set_dir/2"},{"type":"function","title":"Libtailscale.set_ephemeral/2","doc":"","ref":"Libtailscale.html#set_ephemeral/2"},{"type":"function","title":"Libtailscale.set_hostname/2","doc":"","ref":"Libtailscale.html#set_hostname/2"},{"type":"function","title":"Libtailscale.set_logfd/2","doc":"","ref":"Libtailscale.html#set_logfd/2"},{"type":"function","title":"Libtailscale.start/1","doc":"","ref":"Libtailscale.html#start/1"},{"type":"function","title":"Libtailscale.up/1","doc":"","ref":"Libtailscale.html#up/1"},{"type":"function","title":"Libtailscale.write/3","doc":"","ref":"Libtailscale.html#write/3"},{"type":"extras","title":"Libtailscale","doc":"# Libtailscale\n\nThin NIF-wrapper around\n[libtailscale](https://github.com/tailscale/libtailscale/).\n\n> #### Warning {: .warning}\n>\n> Should not be used directly. Use\n> [`gen_tailscale`](https://hex.pm/packages/gen_tailscale) or\n> [`TailscaleTransport`](https://hex.pm/packages/tailscale_transport) instead.","ref":"readme.html"},{"type":"extras","title":"Dependencies - Libtailscale","doc":"Building this package requires access to a Go compiler as well as GCC.","ref":"readme.html#dependencies"},{"type":"extras","title":"Usage - Libtailscale","doc":"There's one working example in `examples/echo.exs`. To run, first run `mix\ndeps.get` and then `mix run examples/echo.exs`. You will need a\n[Tailscale](https://tailscale.com/) account. The first time you run the example,\nit will ask you to log in by following a link. Alternatively, here is the\nsimplest possible echo server:\n\n```elixir\n# Create a new Tailscale server object.\nts = Libtailscale.new()\n\n# Set the Tailscale connection to be ephemeral.\n:ok = Libtailscale.set_ephemeral(ts, 1)\n:ok = Libtailscale.set_hostname(ts, \"libtailscale-echo\")\n\n:ok = Libtailscale.up(ts)\n\n# Create a listener socket using the NIF.\n{:ok, listener_fd} = Libtailscale.listen(ts, \"tcp\", \":1999\")\n\n{:ok, listener_socket} = :socket.open(listener_fd)\n\n# Customer \"accept\" functionality\n{:ok, cmsg} = :socket.recvmsg(listener_socket)\n< > = hd(cmsg.ctrl).data\n\n{:ok, socket} = :socket.open(socket_fd)\n\n# Now echo one message\n{:ok, s} = :socket.recv(socket)\n:ok = :socket.send(socket, s)\n\n# And clean up\n:socket.shutdown(socket, :read_write)\n:socket.close(socket)\n:socket.close(listener_socket)\n```\n\nAfter running the server (wait for the \"state is Running\" message), simply use\n`telnet libtailscale-echo 1999` in another terminal to connect to it over the\ntailnet. The server that's running is a simple echo server that will wait for a\nsingle line of input, return it to the client and then close the connection.","ref":"readme.html#usage"},{"type":"extras","title":"Warning - Libtailscale","doc":"This Elixir library (which is also published to\n[Hex](https://hex.pm/packages/libtailscale), the Elixir package manager), but it\nshould probably not be used directly. Instead, the\n[`gen_tailscale`](https://hex.pm/packages/gen_tailscale) library should be used,\nwhich wraps the libtailscale sockets in a `gen_tcp`-like interface. There's also\nalso [`tailscale_transport`](https://hex.pm/packages/tailscale_transport), which\nallows users to expose their bandit/phoenix-based app directly to their tailnet\nusing `libtailscale` and the `gen_tailscale` wrapper.\n\nEverything in this chain of packages should be considered proof of concept at\nthis point and should not be used for anything important. Especially the\n`gen_tailscale` library has been constructed by crudely hacing the original\n`gen_tcp` module to use `libtailscale` and could use a total rewrite at some\npoint. However, it works well enough that my example application\n[`tschat`](https://github.com/Munksgaard/tschat) is able to accept connections\nfrom different Tailscale users and show their username by retrieving data from\nthe Tailscale connection.","ref":"readme.html#warning"},{"type":"extras","title":"LICENSE","doc":"BSD 3-Clause License\n\nCopyright (c) 2023 Tailscale & AUTHORS.\nAll rights reserved.\n\nRedistribution and use in source and binary forms, with or without\nmodification, are permitted provided that the following conditions are met:\n\n1. Redistributions of source code must retain the above copyright notice, this\n   list of conditions and the following disclaimer.\n\n2. Redistributions in binary form must reproduce the above copyright notice,\n   this list of conditions and the following disclaimer in the documentation\n   and/or other materials provided with the distribution.\n\n3. Neither the name of the copyright holder nor the names of its\n   contributors may be used to endorse or promote products derived from\n   this software without specific prior written permission.\n\nTHIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS \"AS IS\"\nAND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE\nIMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE\nDISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE\nFOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL\nDAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR\nSERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER\nCAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,\nOR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE\nOF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.","ref":"license.html"},{"type":"extras","title":"Changelog","doc":"# Changelog","ref":"changelog.html"},{"type":"extras","title":"Libtailscale v0.1.0 - Changelog","doc":"The initial release of `Libtailscale`.","ref":"changelog.html#libtailscale-v0-1-0"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.38.2"}}